<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReadOnlyLeaseJournalEntry StructType
 * @subpackage Structs
 */
class ReadOnlyLeaseJournalEntry extends ReadOnlyLeaseLedgerItem
{
    /**
     * The details
     * Meta information extracted from the WSDL
     * - arrayType: tns1:ReadOnlyLeaseJournalEntryDetail[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\ReadOnlyLeaseJournalEntryDetail[]
     */
    public $details;
    /**
     * Constructor method for ReadOnlyLeaseJournalEntry
     * @uses ReadOnlyLeaseJournalEntry::setDetails()
     * @param \StructType\ReadOnlyLeaseJournalEntryDetail[] $details
     */
    public function __construct(array $details = array())
    {
        $this
            ->setDetails($details);
    }
    /**
     * Get details value
     * @return \StructType\ReadOnlyLeaseJournalEntryDetail[]|null
     */
    public function getDetails()
    {
        return $this->details;
    }
    /**
     * This method is responsible for validating the values passed to the setDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDetailsForArrayConstraintsFromSetDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $readOnlyLeaseJournalEntryDetailsItem) {
            // validation for constraint: itemType
            if (!$readOnlyLeaseJournalEntryDetailsItem instanceof \StructType\ReadOnlyLeaseJournalEntryDetail) {
                $invalidValues[] = is_object($readOnlyLeaseJournalEntryDetailsItem) ? get_class($readOnlyLeaseJournalEntryDetailsItem) : sprintf('%s(%s)', gettype($readOnlyLeaseJournalEntryDetailsItem), var_export($readOnlyLeaseJournalEntryDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The details property can only contain items of type \StructType\ReadOnlyLeaseJournalEntryDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set details value
     * @throws \InvalidArgumentException
     * @param \StructType\ReadOnlyLeaseJournalEntryDetail[] $details
     * @return \StructType\ReadOnlyLeaseJournalEntry
     */
    public function setDetails(array $details = array())
    {
        // validation for constraint: array
        if ('' !== ($detailsArrayErrorMessage = self::validateDetailsForArrayConstraintsFromSetDetails($details))) {
            throw new \InvalidArgumentException($detailsArrayErrorMessage, __LINE__);
        }
        $this->details = $details;
        return $this;
    }
    /**
     * Add item to details value
     * @throws \InvalidArgumentException
     * @param \StructType\ReadOnlyLeaseJournalEntryDetail $item
     * @return \StructType\ReadOnlyLeaseJournalEntry
     */
    public function addToDetails(\StructType\ReadOnlyLeaseJournalEntryDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReadOnlyLeaseJournalEntryDetail) {
            throw new \InvalidArgumentException(sprintf('The details property can only contain items of type \StructType\ReadOnlyLeaseJournalEntryDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->details[] = $item;
        return $this;
    }
}
