<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TaskList StructType
 * @subpackage Structs
 */
class TaskList extends PWObject
{
    /**
     * The dueDate
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dueDate;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $status;
    /**
     * The tasks
     * Meta information extracted from the WSDL
     * - arrayType: xsd:anyType[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var mixed[]
     */
    public $tasks;
    /**
     * The title
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $title;
    /**
     * Constructor method for TaskList
     * @uses TaskList::setDueDate()
     * @uses TaskList::setStatus()
     * @uses TaskList::setTasks()
     * @uses TaskList::setTitle()
     * @param string $dueDate
     * @param string $status
     * @param mixed[] $tasks
     * @param string $title
     */
    public function __construct($dueDate = null, $status = null, array $tasks = array(), $title = null)
    {
        $this
            ->setDueDate($dueDate)
            ->setStatus($status)
            ->setTasks($tasks)
            ->setTitle($title);
    }
    /**
     * Get dueDate value
     * @return string|null
     */
    public function getDueDate()
    {
        return $this->dueDate;
    }
    /**
     * Set dueDate value
     * @param string $dueDate
     * @return \StructType\TaskList
     */
    public function setDueDate($dueDate = null)
    {
        // validation for constraint: string
        if (!is_null($dueDate) && !is_string($dueDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dueDate, true), gettype($dueDate)), __LINE__);
        }
        $this->dueDate = $dueDate;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\TaskList
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get tasks value
     * @return mixed[]|null
     */
    public function getTasks()
    {
        return $this->tasks;
    }
    /**
     * This method is responsible for validating the values passed to the setTasks method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTasks method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTasksForArrayConstraintsFromSetTasks(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $taskListTasksItem) {
            // validation for constraint: itemType
            if (false) {
                $invalidValues[] = is_object($taskListTasksItem) ? get_class($taskListTasksItem) : sprintf('%s(%s)', gettype($taskListTasksItem), var_export($taskListTasksItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The tasks property can only contain items of type anyType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set tasks value
     * @throws \InvalidArgumentException
     * @param mixed[] $tasks
     * @return \StructType\TaskList
     */
    public function setTasks(array $tasks = array())
    {
        // validation for constraint: array
        if ('' !== ($tasksArrayErrorMessage = self::validateTasksForArrayConstraintsFromSetTasks($tasks))) {
            throw new \InvalidArgumentException($tasksArrayErrorMessage, __LINE__);
        }
        $this->tasks = $tasks;
        return $this;
    }
    /**
     * Add item to tasks value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \StructType\TaskList
     */
    public function addToTasks($item)
    {
        // validation for constraint: itemType
        if (false) {
            throw new \InvalidArgumentException(sprintf('The tasks property can only contain items of type anyType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->tasks[] = $item;
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \StructType\TaskList
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->title = $title;
        return $this;
    }
}
